﻿using System;
using System.IO;
using System.Net.Sockets;
using System.Threading;

namespace EchoTcpClient
{
    class Program
    {
        private const string Server = "127.0.0.1";
        private const int Port = 7;

        static void Main()
        {
            SingleRequest();
            //MultipleRequests();
        }

        private static void SingleRequest()
        {
            // https://msdn.microsoft.com/en-us/library/system.net.sockets.tcpclient.aspx
            using (TcpClient client = new TcpClient(Server, Port))
            {
                NetworkStream stream = client.GetStream();
                StreamWriter writer = new StreamWriter(stream);
                string request = "Hello world";
                Thread.Sleep(10000);

                writer.WriteLine(request);
                writer.Flush();
                StreamReader reader = new StreamReader(stream);
                string response = reader.ReadLine();
                Console.WriteLine(response);
            }
        }

        private static void MultipleRequests()
        {
            while (true)
            {

                using (TcpClient client = new TcpClient(Server, Port))
                {
                    NetworkStream stream = client.GetStream();
                    StreamWriter writer = new StreamWriter(stream);
                    Console.Write("Request: ");
                    string request = Console.ReadLine();
                    //string request = "Hello world";
                    if ("stop".Equals(request)) break;
                    writer.WriteLine(request);
                    writer.Flush();
                    StreamReader reader = new StreamReader(stream);
                    string response = reader.ReadLine();
                    Console.WriteLine("Response: " + response);
                }
            }
        }
    }
}
